// BattleField.cpp: CBattleField NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "inc.h"
#include "BattleField.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CBattleField::CBattleField()
{
	m_Rect.left=96;
	m_Rect.right=96+BLOCKSIZE*XSIZE;
	m_Rect.top=16;
	m_Rect.bottom=16+BLOCKSIZE*YSIZE;

	Init();
}

CBattleField::~CBattleField()
{

}

bool CBattleField::Overlap(CBlock *pBlock)
{
	//Վ//////////////
	if( pBlock->x==-2 )
		return true;
	if( pBlock->x==-1 && (pBlock->var[0][0]!=0 || pBlock->var[0][1]!=0) )
		return true;

	if( pBlock->x==7 )
		return true;
	if( pBlock->x==6 && (pBlock->var[1][0]!=0 || pBlock->var[1][1]!=0) )
		return true;

	if( pBlock->y > 14 )
		return true;
	/////////////////////////

	for( int x=0; x!=2; x++ )
	{
		for( int y=0; y!=2; y++ )
		{
			if( pBlock->var[x][y] * m_List[pBlock->x+x][(int)(ceil(pBlock->y)-y-1)] != 0 )
				return true;
		}
	}

	return false;
}

void CBattleField::SetBlock(CBlock *pBlock)
{
	for( int x=0; x!=2; x++ )
	{
		for( int y=0; y!=2; y++ )
		{
			if( pBlock->var[x][y] ==0 )
				continue;

			int xxx = pBlock->x+x;
			int yyy= (int)(ceil(pBlock->y)-1-y);
			if( xxx<0 || xxx>=XSIZE || yyy<0 || yyy>=YSIZE )
				continue;

			m_List[xxx][yyy] = pBlock->var[x][y];
		}
	}
}

void CBattleField::Draw(CDirectDrawSurface *pSurf)
{
	RECT rcFrom={0,0,g.m_ImageList[0].Height(),g.m_ImageList[0].Width()};

	for( int x=0; x!=XSIZE; x++ )
	{
		for( int y=0; y!=YSIZE; y++ )
		{
			RECT rcTo = {m_Rect.left+x*BLOCKSIZE , m_Rect.top+y*BLOCKSIZE,
						 m_Rect.left+(x+1)*BLOCKSIZE , m_Rect.top+(y+1)*BLOCKSIZE };
			pSurf->Blt(&rcTo,&g.m_ImageList[ m_List[x][y]+7*m_EList[x][y] ],&rcFrom,DDBLT_WAIT,NULL);
		}
	}
}

void CBattleField::DrawBlock(CBlock *pBlock, CDirectDrawSurface *pSurf)
{
	RECT rcFrom={0,0,g.m_ImageList[0].Height(),g.m_ImageList[0].Width()};

	for( int x=0; x!=2; x++ )
	{
		for( int y=0; y!=2; y++ )
		{
			if( pBlock->var[x][y]==0 )
				continue;

			RECT rcTo = {m_Rect.left+(pBlock->x+x)*BLOCKSIZE , (int)(m_Rect.top+(pBlock->y-y-1)*BLOCKSIZE),
						 m_Rect.left+(pBlock->x+x+1)*BLOCKSIZE , (int)(m_Rect.top+(pBlock->y-y)*BLOCKSIZE) };
			pSurf->Blt(&rcTo,&g.m_ImageList[pBlock->var[x][y]],&rcFrom,DDBLT_WAIT,NULL);
		}
	}
}

void CBattleField::Break()
{
//
	for( int x=0; x!=XSIZE; x++ )
	{
		for( int y=YSIZE-1; y!=0; y-- )
		{
			if( m_List[x][y]==0 )
			{
				for( int yy=y-1; yy!=-1; yy-- )
				{
					if( m_List[x][yy]!=0 )
						break;
				}
				for( int i=0; i<=yy; i++ )
				{
					m_List[x][y-i]=m_List[x][yy-i];
					m_List[x][yy-i]=0;
				}
			}
		}
	}
}

void CBattleField::Erase(int k)
{
	int c=0;

	for( int x=0; x!=XSIZE; x++ )
	{
		for( int y=0; y!=YSIZE; y++ )
			if( m_EList[x][y]==1 )
			{
				c++;
				m_List[x][y]=0;
				m_EList[x][y]=0;
			}
	}

	//  k Aڂ c ꍇ̓_.....

	m_Score += k*c;	//ЂႠ
}

void CBattleField::Init()
{
	m_Score = 0;

	for( int x=0; x!=XSIZE; x++ )
	{
		for( int y=0; y!=YSIZE; y++ )
		{
			m_EList[x][y]=0;
			m_List[x][y]=0;
		}
	}
}

bool CBattleField::IsDead()
{
	for( int x=0; x!=XSIZE; x++ )
		if( m_List[x][0]!=0 )
			return true;

	return false;
}

bool CBattleField::EraseSearch()
{
	bool ans = false;
	int x,y,i,j;

	for( x=0; x!=XSIZE; x++ )
	{
		for( y=0; y!=YSIZE-1; y++ )
		{
			if( m_List[x][y]==0 )
				continue;
			
			int s=m_List[x][y];
			for( i=y+1; i!=YSIZE; i++ )
			{
				s+=m_List[x][i];
				if( s==7 )
				{
					for( j=0; j!=i-y+1; j++ )
					{
						ans = true;
						m_EList[x][y+j]=1;
					}
					break;
				}
				else if( i==y+2 && s==21 )
				{
					m_EList[x][y]=m_EList[x][y+1]=m_EList[x][y+2]=1;
					ans = true;
					break;
				}
				else if( s>7 && s!=14 )
					break;
			}
		}
	}

	for( y=0; y!=YSIZE; y++ )
	{
		for( x=0; x!=XSIZE-1; x++ )
		{
			if( m_List[x][y]==0 )
				continue;
			
			int s=m_List[x][y];
			for( i=x+1; i!=XSIZE; i++ )
			{
				if( m_List[i][y]==0 )
					break;

				s+=m_List[i][y];
				if( s==7 )
				{
					for( j=0; j!=i-x+1; j++ )
					{
						ans = true;
						m_EList[x+j][y]=1;
					}
					break;
				}
				else if( i==x+2 && s==21 )
				{
					ans = true;
					m_EList[x][y]=m_EList[x+1][y]=m_EList[x+2][y]=1;
					break;
				}
				else if( s>7 && s!=14 )
					break;
			}
		}
	}

	return ans;
}

void CBattleField::DrawScore(CDirectDrawSurface *pSurf)
{
	char str[100];
	sprintf(str,"Score:%d",m_Score);

	HDC hdc;
	if( DD_OK != pSurf->GetDC(&hdc) )	return;

		TextOut(hdc , m_Rect.right+10 , m_Rect.top+50 , str,strlen(str));

	pSurf->ReleaseDC(hdc);
}
